/*
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/

 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.

 * The Original Code is Rhino code, released
 * May 6, 1999.

 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1997-1999 Netscape Communications Corporation. All
 * Rights Reserved.

 * Contributor(s): 

 * Alternatively, the contents of this file may be used under the
 * terms of the GNU Public License (the "GPL"), in which case the
 * provisions of the GPL are applicable instead of those above.
 * If you wish to allow use of your version of this file only
 * under the terms of the GPL and not to allow others to use your
 * version of this file under the NPL, indicate your decision by
 * deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL.  If you do not delete
 * the provisions above, a recipient may use your version of this
 * file under either the NPL or the GPL.
 */
/* Header files */
#ifdef VX
#include <taskLib.h>
#endif
#include "js-runtime.h"
#include "js-runtimeexception.h"
#include "js-exceptionhandler.h"
#include "js-zone.h"
#include "ewb-sys.h"
#include "ewb-sys-if.h"

#include "js-api.h"
#include "ewb-dbg.h"
#ifndef SHELL
# include "ewb-trace.h"
#endif
extern int ewbPrintOn;

/* Classes */
void *
JSZone::Allocator::memalign(JSContext *cx, size_t alignment, size_t size)
{
    void *ptr = runtime->localZoneHeap.memalign(alignment, size);

    if(ptr == NULL){
	if( ewbPrintOn ) {printf("Call GC. Because EWB Compile mem Exhaused(2). But, This is no problem.");}
	char jsLogbuf[128];
	memset(jsLogbuf, 0, sizeof(jsLogbuf));
	sprintf(jsLogbuf,"Call GC from CompilePart(a) size:%d. 1st Log is Befor GC. 2nd is after.\n",size);
	EwbSetLog(jsLogbuf);
	JS_GCMemFreeShow(cx, 1);
        JS_GC(cx);
	JS_GCMemFreeShow(cx, 1);

	ptr = runtime->localZoneHeap.memalign(alignment, size);
	if(ptr == NULL){
	    EwbSetLog("JS Compile Memory Exhaused. Be necessary to expand JS Compile Memory\n");
 #ifndef SHELL
	    EwbNotifyError(EWB_ERROR_JS_MEMORY);
 #endif
            #if defined(SUNOS5) || defined(LINUX)
	        exit(1);
            #elif defined(VX)
	        taskSuspend( 0 );
            #else
	        ->
            #endif
	}
    }
    return ptr;
}

void *
JSZone::Allocator::malloc(JSContext *cx, size_t size)
{
    void *ptr;
    ptr = runtime->localZoneHeap.malloc(size);

    if(ptr == NULL){
	if( ewbPrintOn ) {printf("Call GC. Because EWB Compile mem Exhaused(3). But, This is no problem.");}
	char jsLogbuf[128];
	memset(jsLogbuf, 0, sizeof(jsLogbuf));
	sprintf(jsLogbuf,"Call GC from CompilePart(b) size:%d. 1st Log is Befor GC. 2nd is after.\n",size);
	EwbSetLog(jsLogbuf);
	JS_GCMemFreeShow(cx, 1);
        JS_GC(cx);
	JS_GCMemFreeShow(cx, 1);

	ptr = runtime->localZoneHeap.malloc(size);
	if(ptr == NULL){
	    EwbSetLog("JS Compile Memory Exhaused. Be necessary to expand JS Compile Memory\n");
 #ifndef SHELL
	    EwbNotifyError(EWB_ERROR_JS_MEMORY);
 #endif
            #if defined(SUNOS5) || defined(LINUX)
	        exit(1);
            #elif defined(VX)
	        taskSuspend( 0 );
            #else
	        ->
            #endif
	}
    }
    return ptr;
}

void
JSZone::Allocator::free(void *ptr)
{
    runtime->localZoneHeap.free(ptr);

}
JSZone::Allocator::Allocator(JSRuntime *runtime)
{
    this->runtime = runtime;
}

void
JSZone::PhaseListener::markAll(JSContext* cx)
{
}
void
JSZone::PhaseListener::finalize(JSContext* cx, void *obj)
{
}
void
JSZone::PhaseListener::stopWorld()
{
}
void
JSZone::PhaseListener::resumeWorld()
{
}

#ifdef THREADS
void
JSZone::MutexListener::lock()
{
}
void
JSZone::MutexListener::unlock()
{
}
#endif
void
JSZone::destroy(JSRuntime *runtime)
{
    /*
     * Don't use 'this->~JSZone', beacuse allocator is destroied before
     * calling ~JSGCMemory
     */
    this->~JSGCMemory();
    JSRuntimeNew::destroy(runtime);
}

JSZone::JSZone(JSRuntime *runtime)
		: allocator(runtime)
{
    setMemoryAllocator(&allocator);
    setPhaseListener(&phaseListener);
#ifdef THREADS
    setMutexListener(&mutexListener);
#endif

    disabled = True;
}

